%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Attention, ce script utilise les fonctions
% * newton distribue avec les sujets de TP.
% ger=0 pour faire sujet, corrigs avec matex
% ger=1 pour script de correction
ger=1;

% donnes
a=10;
epsi=1e-3;
x0=5;

%% question 3)
if ger==1
    disp('question 3)');
end
nmax=10;
f=@(x,A) x.^2-A;
df=@(x,A) 2*x;
[xvect,xdif,fx,nit]=newton(x0,eps,nmax,@(x) f(x,a),@(x) df(x,a));
u=find(abs(xvect-sqrt(a))<=epsi);
xvect=xvect(1:min(u));
if ger==0
    stocke_tableau_tex([(0:length(xvect)-1).',xvect.',abs(xvect-sqrt(a)).'],'l',12,10,'f',0,[],1,4,2,'tab_examencorMNBA13_10',{'tab_examencorMNBA13_10','Itrs $x_n$ de Newton',1},{'$n$','$x_n$','$|x_n-\sqrt{a}|$'});
end
if ger==1
    disp('Itrs, Erreur');
    disp([xvect.',abs(xvect-sqrt(a)).']);
    pause;
end



%% question 5)
if ger==1
    disp('Question 5');
end
x0b=10;
[xvect,xdif,fx,nit]=newton(x0b,eps,nmax,@(x) f(x,a),@(x) df(x,a),1);
if ger==0
    print -depsc dessins/fig20examcorMNBA13.eps;
end