%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Attention, ce script utilise les fonctions
% * eul distribue avec les sujets de TP.
% ger=0 pour faire sujet, corrigs avec matex
% ger=1 pour script de correction
ger=1;

% donnes
yp0=4;
y0=0;
h=0.25;
tmax=3;


%% 
% ATTENTION Rsultats suivants obtenus sous matlab 7 (ne marchent pas
% matlab 8 !!!)
% y=dsolve('D2y=-2*y*Dy','y(0)=y0','Dy(0)=yp0','t');
% syms t y0 yp0;
% disp('y');
% disp(y);
% pretty(y);
% disp('limite en + infini');
% disp(limit(y,t,inf));
% disp('latex(y)');
% disp(latex(y));
% yp0=4;
% y0=0;
% yb=dsolve('D2y=-2*y*Dy',['y(0)=',num2str(y0)],['Dy(0)=',num2str(yp0)],'t');
% disp('Cas particulier');
% disp('y');
% disp(yb);
% pretty(yb);
% disp('limite en + infini');
% disp(limit(yb,t,inf));
% disp('latex(yb)');
% disp(latex(yb));
% % % % Rsultats obtenus
% % % y
% % % tanh(t*(yp0+y0^2)^(1/2)+atanh(y0/(yp0+y0^2)^(1/2)))*(yp0+y0^2)^(1/2)
% % %  
% % %  
% % %                          2 1/2               y0                  2 1/2
% % %          tanh(t (yp0 + y0 )    + atanh(--------------)) (yp0 + y0 )
% % %                                                 2 1/2
% % %                                        (yp0 + y0 )
% % % limite en + infini
% % % limit(tanh(t*(yp0+y0^2)^(1/2)+atanh(y0/(yp0+y0^2)^(1/2)))*(yp0+y0^2)^(1/2),t = Inf)
% % %  
% % % latex(y)
% % % \tanh \left( t\sqrt {{\it yp0}+{{\it y0}}^{2}}+{\it arctanh} \left( {\frac {{\it y0}}{\sqrt {{\it yp0}+{{\it y0}}^{2}}}} \right)  \right) \sqrt {{\it yp0}+{{\it y0}}^{2}}
% % % Cas particulier
% % % y
% % % 2*tanh(2*t)
% % %  
% % %  
% % %                                   2 tanh(2 t)
% % % limite en + infini
% % % 2
% % %  
% % % latex(yb)
% % % 2\,\tanh \left( 2\,t \right)
yexa=inline('2*tanh(2*t)');
t=linspace(0,tmax,1000);
clf;
plot(t,yexa(t));
ylim([0 2+1]);
grid on;
xlabel('t');
ylabel('y(t)');
if ger==1
    pause;
else
    print -depsc dessins/fig10examMNBA13.eps;
end

%% question 1)
if ger==1
    disp('question 1)');
end
hb=0.1;
F=@(t,Y)[Y(2);-2*Y(1)*Y(2)];
Y0=[y0 yp0];
tspan=[0,tmax];
[te,ye]=eul(F,tspan,Y0,h);
nf=find(diff(ye(:,1))==0);
nf=nf(1)-1;
[trk,yrk]=rk4(F,tspan,Y0,h);
[teb,yeb]=eul(F,tspan,Y0,hb);
[tode45,yode45]=ode45(F,t,[y0 yp0]);
if ger==1
    disp('t y y'' approchs');
    disp([te,(ye(:,1)),(ye(:,2))]);
    disp(['A partir de n=',int2str(nf),' la solution ne bouge plus.']);
    pause;
else
    stocke_tableau_tex([(0:length(ye)-1).',te,(ye(:,1)),(ye(:,2))],'l',3,2,'f',0,[],1,4,2,'tab_examencorMNBA13_20',{'tab_examencorMNBA13_20','Valeurs approches par Euler progressif',1},{'$n$','$t_n$','$y_1^n$','$y_2^n$'});
end



%% question 2)
if ger==1
    disp('question 2)');
end
clf;
plot(te,ye(:,1),'-o',teb,yeb(:,1),'-.',trk,yrk(:,1),':',tode45,yode45(:,1),t,yexa(t));
ylim([0 3]);
grid on;
xlabel('t');
ylabel('y(t)');
legend(['Euler progressif (h=',num2str(h),')'],['Euler progressif (h=',num2str(hb),')'],['RK4 (h=',num2str(h),')'],'ode45','Exact',0);
if ger==0
    print -depsc dessins/fig30examcorMNBA13.eps;
end